function [support] = SUnGP(D, Y, param)
%%SUnGP: Sparse Unmixing via Greedy Pursuit [1]
%   [1] Naveed Akhtar, Faisal Shafait and Ajmal Mian,'SUnGP: Agreedy sparse
%   approximation algorithm for hyperspectral unmixing', In Proc. ICPR,2014.
%%
p = param.desiredIteraitons;
L = param.L;

support = [];
[m,n]=size(Y);
Dn = normc(D);
for j = 1:n
    y = Y(:,j);
    r = y;
    s = [];
    for jj = 1:p
        r0 = r;
        proj = Dn'*normc(r);
        [v indx] = sort(proj, 'descend');
        tt = indx(1:L)';
        temp_s = [tt s];
        a = lsqnonneg(D(:,temp_s),y);
        [val ind] = max(a(1:L,1)); 
        s = [s tt(ind(1,1))];
        a = lscov(D(:,s), y);
        r = y - D(:,s)*a;
        temp_s = [];
    end
    support = [support s'];
end
end

